var DIARY_FOLDER = '/diary';
var YEAR_BLOCK_ID = 'years';
var MONTH_BLOCK_ID = 'months';
var DAY_BLOCK_ID = 'days';
var DATE_ID = '_date';
var CONTENTS_ID = '_contents';
var LATEST_YEAR = 2009;
var LATEST_MONTH = 11;

/* ------------------------------------------------------------------------------ */

var year = 0;
var month = 0;
var diariesChache = null;

/* ------------------------------------------------------------------------------ */

// onload
addEvent(window, 'load', showLatest);

function showLatest(e) {
    createLoading();
    queryList = getQueryList();
    if(queryList) {
        if(queryList.getValue('year') != null)
            year = queryList.getValue('year');
        if(queryList.getValue('month') != null)
            month = queryList.getValue('month');
    } else {
        year = LATEST_YEAR;
        month = LATEST_MONTH;
    }
    
    showYears();
    if(0 < year)
        showMonths();
    if(0 < month)
        showDays();
}

/* ------------------------------------------------------------------------------ */

function showYears() {
    clearMonths();
    clearDays();
    showLoading();
    new Ajax.Request(
        DIARY_FOLDER + '/years.xml',
        {
            method: 'get',
            onSuccess: yearsSuccess,
            onComplete: yearsComplete,
            onFailure: yearsFailure
        }
    );
}
function yearsSuccess(file) {
    hideLoading();
    addYears(file.responseXML.documentElement);
}
function yearsComplete() { }
function yearsFailure() { }

/* ------------------------------------------------------------------------------ */

function addYears(root) {
    var yearElements = $A(root.getElementsByTagName('year'));
    var years = new Array();
    yearElements.each(function(yearElement) {
        years.push(yearElement.firstChild.nodeValue);
    });
    years.sort();
    years.each(function(y) {
        var buttonContainer = document.createElement('span');
        buttonContainer.setAttribute('class', 'buttonContainer');
        buttonContainer.setAttribute('className', 'buttonContainer');
        var yearButton = document.createElement('span');
        yearButton.appendChild(document.createTextNode(y + '年'));
        yearButton.setAttribute('id', 'year' + y);
        yearButton.setAttribute('class', 'yearButton');
        yearButton.setAttribute('className', 'yearButton');
        addEvent(yearButton, 'click', yearButtonClick);
        buttonContainer.appendChild(yearButton);
        $(YEAR_BLOCK_ID).appendChild(buttonContainer);
    });
    refreshYearButtons();
}

function yearButtonClick(e) {
    var button = getEventSource(e);
    if(button.attributes['class'].nodeValue == 'selectedYearButton')
        return;
    year = button.id.replace('year', '');
    month = 0;
    refreshYearButtons();
    refreshMonthButtons();
    showMonths();
}

function refreshYearButtons() {
    var spans = $A($(YEAR_BLOCK_ID).getElementsByTagName('span'));
    spans.each(function(span) {
        if(span.getAttribute('class') == 'buttonContainer')
            return;
        if(span.id == 'year' + year) {
            span.setAttribute('class', 'selectedYearButton');
            span.setAttribute('className', 'selectedYearButton');
        } else {
            span.setAttribute('class', 'yearButton');
            span.setAttribute('className', 'yearButton');
        }
    });
}

/* ------------------------------------------------------------------------------ */

function showMonths() {
    clearMonths();
    clearDays();
    showLoading();
    new Ajax.Request(
        DIARY_FOLDER + '/' + year + '/months.xml',
        {
            method: 'get',
            onSuccess: monthsSuccess,
            onComplete: monthsComplete,
            onFailure: monthsFailure
        }
    );
}
function monthsSuccess(file) {
    hideLoading();
    addMonths(file.responseXML.documentElement);
}
function monthsComplete() { }
function monthsFailure() { }

/* ------------------------------------------------------------------------------ */

function clearMonths() {
    clearChilds($(MONTH_BLOCK_ID));
}

function addMonths(root) {
    clearMonths();
    var monthElements = $A(root.getElementsByTagName('month'));
    var months = new Array();
    monthElements.each(function(monthElement) {
        months.push(monthElement.firstChild.nodeValue);
    });
    months.sort(function(a, b) { return a - b; });
    months.each(function(m) {
        var buttonContainer = document.createElement('span');
        buttonContainer.setAttribute('class', 'buttonContainer');
        buttonContainer.setAttribute('className', 'buttonContainer');
        var monthButton = document.createElement('span');
        monthButton.appendChild(document.createTextNode(m + '月'));
        monthButton.setAttribute('id', 'month' + m);
        monthButton.setAttribute('class', 'monthButton');
        monthButton.setAttribute('className', 'monthButton');
        addEvent(monthButton, 'click', monthButtonClick);
        buttonContainer.appendChild(monthButton);
        $(MONTH_BLOCK_ID).appendChild(buttonContainer);
    });
    refreshMonthButtons();
}

function monthButtonClick(e) {
    var button = getEventSource(e);
    /*
    if(button.attributes['class'].nodeValue == 'selectedMonthButton')
        return;
    */
    month = button.id.replace('month', '');
    refreshMonthButtons();
    showDays(month);
}

function refreshMonthButtons() {
    var spans = $A($(MONTH_BLOCK_ID).getElementsByTagName('span'));
    spans.each(function(span) {
        if(span.getAttribute('class') == 'buttonContainer')
            return;
        if(span.id == 'month' + month) {
            span.setAttribute('class', 'selectedMonthButton');
            span.setAttribute('className', 'selectedMonthButton');
        } else {
            span.setAttribute('class', 'monthButton');
            span.setAttribute('className', 'monthButton');
        }
    });
}

/* ------------------------------------------------------------------------------ */

var Diary = Class.create();
Diary.prototype =
{
    id: null,
    date: null,
    title: null,
    contents: null,
    getId: function() { return this.id; },
    getDate: function() { return this.date; },
    getTitle: function() { return this.title; },
    getContents: function() { return this.contents; },
    initialize: function(date, title, contents) {
        this.id = 'day_' + toD2String(date.getDate());
        this.date = date;
        this.title = title;
        this.contents = contents;
    },
    toNode: function() {
        var node = document.createElement('div');
        node.setAttribute('id', this.id);
        node.setAttribute('class', 'diaryBlock');
        node.setAttribute('className', 'diaryBlock');
        var dateNode = document.createElement('div');
        dateNode.setAttribute('id', this.id + DATE_ID);
        dateNode.setAttribute('class', 'diaryDate');
        dateNode.setAttribute('className', 'diaryDate');
        dateNode.appendChild(document.createTextNode(this.date.toString()));
        addEvent(dateNode, 'click', showDiary);
        node.appendChild(dateNode);
        var contentsNode = document.createElement('div');
        contentsNode.setAttribute('id', this.id + CONTENTS_ID);
        contentsNode.setAttribute('class', 'diaryContents');
        contentsNode.setAttribute('className', 'diaryContents');
        node.appendChild(contentsNode);
        return node;
    }
};

/* ------------------------------------------------------------------------------ */

function showDays() {
    showLoading();
    new Ajax.Request(
        DIARY_FOLDER + '/' + year + '/' + toD2String(month) + '/diarys.xml',
        {
            method: 'get',
            onSuccess: daysSuccess,
            onComplete: daysComplete,
            onFailure: daysFailure
        }
    );
}
function daysSuccess(file) {
    hideLoading();
    addDays(file.responseXML.documentElement);
}
function daysComplete() { }
function daysFailure() { }

/* ------------------------------------------------------------------------------ */

function clearDays() {
    clearChilds($(DAY_BLOCK_ID));
    diariesChache = null;
}

function addDays(root) {
    clearDays();
    var diaryElements = $A(root.getElementsByTagName('diary'));
    var diaries = new Array();
    diaryElements.each(function(diaryElement) {
        var dateElement = diaryElement.getElementsByTagName('date')[0];
        var date = new Date(Date.parse(dateElement.firstChild.nodeValue));
        var titleElement = null;
        var titleElements = diaryElement.getElementsByTagName('title');
        if(0 < titleElements.length)
            titleElement = titleElements[0];
        var contentsElement = diaryElement.getElementsByTagName('contents')[0];
        diaries.push(
            new Diary(
                date,
                titleElement ? titleElement.firstChild.nodeValue : null,
                contentsElement
            )
        );
    });
    diaries.sort(function(a, b) { return b.getDate().getTime() - a.getDate().getTime(); });
    diariesChache = diaries;
    diariesChache.each(function(diary) {
        var diaryNode = diary.toNode();
        $(DAY_BLOCK_ID).appendChild(diaryNode);
    });
}

function showDiary(e) {
    var dateNode = getEventSource(e);
    var diaryNode = dateNode.parentNode;
    var contentsNode = $(diaryNode.id + CONTENTS_ID);
    var diary = null;
    diariesChache.each(function(diaryChache) {
        if(diaryChache.getId() == diaryNode.id && diary == null) {
            diary = diaryChache;
        }
    });
    if(diary == null)
        return;
    clearChilds(contentsNode);
    contentsNode.setAttribute('id', diary.id + CONTENTS_ID);
    contentsNode.setAttribute('class', 'openedDiaryContents');
    contentsNode.setAttribute('className', 'openedDiaryContents');
    dateNode.setAttribute('class', 'openedDiaryDate');
    dateNode.setAttribute('className', 'openedDiaryDate');
    if(diary.title) {
        var titleNode = document.createElement('h3');
        titleNode.appendChild(document.createTextNode(diary.title));
        contentsNode.appendChild(titleNode);
    }
    var contents = document.createElement('div');
    $A(diary.contents.childNodes).each(function(child) {
        var copy = copyNode(child);
        if(copy != null)
            contents.appendChild(copy);
    });
    contentsNode.appendChild(contents);
    removeEvent(dateNode, 'click', showDiary);
    addEvent(dateNode, 'click', hideDiary);
}

function hideDiary(e) {
    var dateNode = getEventSource(e);
    var diaryNode = dateNode.parentNode;
    var contentsNode = $(diaryNode.id + CONTENTS_ID);
    clearChilds(contentsNode);
    contentsNode.setAttribute('id', diaryNode.id + CONTENTS_ID);
    contentsNode.setAttribute('class', 'diaryContents');
    contentsNode.setAttribute('className', 'diaryContents');
    dateNode.setAttribute('class', 'diaryDate');
    dateNode.setAttribute('className', 'diaryDate');
    removeEvent(dateNode, 'click', hideDiary);
    addEvent(dateNode, 'click', showDiary);
}
